Index: src/uk/me/parabola/mkgmap/reader/osm/POIGeneratorHook.java
===================================================================
--- src/uk/me/parabola/mkgmap/reader/osm/POIGeneratorHook.java	(revision 3598)
+++ src/uk/me/parabola/mkgmap/reader/osm/POIGeneratorHook.java	(working copy)
@@ -366,21 +366,35 @@
 			if (r instanceof MultiPolygonRelation == false) {
 				continue;
 			}
-			// boundary relations may have a node with role admin_centre, if yes, use the 
-			// location of it
 			Node existingPOI = null;
-			if ("boundary".equals(r.getTag("type")) && "administrative".equals(r.getTag("boundary"))){
+			String relName = getName(r);
+			if (relName != null){
 				for (Entry<String, Element> pair : r.getElements()){
 					String role = pair.getKey();
-					Element el = pair.getValue(); 
-					if ("admin_centre".equals(role)){
-						if (el instanceof Node){
-							String bName = getName(r);
-							String pName = getName(el);
-							if (bName != null && bName.equals(pName))
+					Element el = pair.getValue();
+					if (el instanceof Node){
+						if ("admin_centre".equals(role)){
+							if ("boundary".equals(r.getTag("type")) && "administrative".equals(r.getTag("boundary"))){
+								// boundary relations may have a node with role admin_centre, if yes, use the 
+								// location of it
+								String pName = getName(el);
+								if (relName.equals(pName)){
+									existingPOI = (Node) el;
+									if (log.isDebugEnabled())
+										log.debug("using admin_centre node as location for POI for rel",r.getId(),relName,"at",((Node) el).getLocation().toDegreeString());
+									break;
+								}
+							}
+						} else if ("label".equals(role)){
+							String label = getName(el);
+							if (relName.equals(label)){
 								existingPOI = (Node) el;
+								log.error("using label node as location for POI for rel",r.getId(),relName,"at",((Node) el).getLocation().toDegreeString());
+								break;
+							} else {
+								log.error("rel",r.toBrowseURL(),",node with role label is ignored because it has a different name");
+							}
 						}
-						break;
 					}
 				}
 			}
